var _operators;

import { CHANGED, EQUALS, EXISTS, GREATERTHAN, GREATERTHANEQUALS, IN, INPATTERN, LESSTHAN, LESSTHANEQUALS, NEXISTS, NIN, NINPATTERN, NSUPERSET, SUPERSET, HIDDEN } from './constants';
import { pickFieldById } from './fields';
import { LocalizationFactory } from '../Standard/Localization/LocalizationFactory';
export var operators = (_operators = {}, _operators[IN] = function (id, values, fields) {
  var field = pickFieldById(fields, id);
  var shouldApply = values.some(function (value) {
    return value === field.value;
  });
  return shouldApply;
}, _operators[NIN] = function (id, values, fields) {
  return !operators.IN(id, values, fields);
}, _operators[INPATTERN] = function (id, values, fields) {
  var field = pickFieldById(fields, id);
  var shouldApply = values.some(function (value) {
    var _field$value;

    return (_field$value = field.value) == null ? void 0 : _field$value.match(value);
  });
  return shouldApply;
}, _operators[NINPATTERN] = function (id, values, fields) {
  return !operators.INPATTERN(id, values, fields);
}, _operators[EXISTS] = function (id, fields) {
  var field = pickFieldById(fields, id);
  return Boolean(field && field.value);
}, _operators[NEXISTS] = function (id, fields) {
  return !operators.EXISTS(id, fields);
}, _operators[CHANGED] = function (id, changeField) {
  return id === changeField;
}, _operators[EQUALS] = function (id, values, fields, locale) {
  var field = pickFieldById(fields, id);
  var value = field.value;
  var equalTo = values[0];

  if (typeof equalTo === 'number') {
    var localization = LocalizationFactory({
      value: value,
      locale: locale
    });
    value = localization.fromStringToLocaleFloat();
  }

  var shouldApply = equalTo === value;
  return shouldApply;
}, _operators[GREATERTHAN] = function (id, values, fields, locale) {
  var field = pickFieldById(fields, id);
  var value = field.value;

  if (typeof field.value === 'string') {
    var localization = LocalizationFactory({
      value: value,
      locale: locale
    });
    value = localization.fromStringToLocaleFloat();
  }

  var shouldApply = value > values[0];
  return shouldApply;
}, _operators[GREATERTHANEQUALS] = function (id, values, fields, locale) {
  var field = pickFieldById(fields, id);
  var value = field.value;

  if (typeof field.value === 'string') {
    var localization = LocalizationFactory({
      value: value,
      locale: locale
    });
    value = localization.fromStringToLocaleFloat();
  }

  var shouldApply = value >= values[0];
  return shouldApply;
}, _operators[LESSTHAN] = function (id, values, fields, locale) {
  var field = pickFieldById(fields, id);
  var value = field.value;

  if (typeof field.value === 'string') {
    var localization = LocalizationFactory({
      value: value,
      locale: locale
    });
    value = localization.fromStringToLocaleFloat();
  }

  var shouldApply = value < values[0];
  return shouldApply;
}, _operators[LESSTHANEQUALS] = function (id, values, fields, locale) {
  var field = pickFieldById(fields, id);
  var value = field.value;

  if (typeof field.value === 'string') {
    var localization = LocalizationFactory({
      value: value,
      locale: locale
    });
    value = localization.fromStringToLocaleFloat();
  }

  var shouldApply = value <= values[0];
  return shouldApply;
}, _operators[SUPERSET] = function (id, values, fields) {
  var _pickFieldById = pickFieldById(fields, id),
      fieldValue = _pickFieldById.value;

  var isEmpty = !fieldValue.length;
  var hasExpectedValues = values.every(function (i) {
    return fieldValue.includes(i);
  });
  return !isEmpty && hasExpectedValues;
}, _operators[NSUPERSET] = function (id, values, fields) {
  var _pickFieldById2 = pickFieldById(fields, id),
      fieldValue = _pickFieldById2.value;

  var isEmpty = !fieldValue.length;
  var hasNotExpectedValues = values.some(function (i) {
    return !fieldValue.includes(i);
  });
  return isEmpty || hasNotExpectedValues;
}, _operators[HIDDEN] = function (id, fields) {
  var _pickFieldById3 = pickFieldById(fields, id),
      hidden = _pickFieldById3.hidden;

  return !!hidden;
}, _operators);